Subject: [U-Boot] [RFC] Kbuild support for ARM FIT images

From: [email-masked] (Stephen Warren)
Date: Mon, 18 Mar 2013 12:14:47 -0600

On 03/18/2013 12:04 PM, Pavel Machek wrote:
> On Mon 2013-03-18 17:57:46, Russell King - ARM Linux wrote:
>> On Mon, Mar 18, 2013 at 06:49:32PM +0100, Pavel Machek wrote:
>>> What I wanted to say is that kernel build traditionaly produced
>>> something useful, something bootloader can actually boot. Currently,
>>> make uImage produces u-boot image. Please keep that capability.
>>
>> Unfortunately, there is a fundamental problem with uImage.  It encodes
>> the load address, and that is utterly incompatible with the goal of
>> having a kernel image which boots on multiple platforms.
>>
>> uImage isn't going anywhere for the time being, but you will find
>> that:
>>
>> a) recent kernels will just wrap the zImage without a DTB, so
>>    appended DTBs can't be used with it
>> b) it won't work with MULTIPLATFORM-enabled kernels, unless you
>>    provide make with a LOADADDR= argument to tell it where the
>>    uImage is to be loaded - which is platform specific.
>>
>> (b) fundamentally can't be solved in kbuild.  If you want to use
>> uImage with multiple platforms from the same zImage, then you need
>> to generate multiple uImage files with different load addresses.
>> That's purely - and solely - down to the dysfunctional uImage format.
> 
> I know. uImage is not perfect. But solution should be "adopt a better
> format" (ARM FIT?), not "drop support for making useful images
> altogether" as Olof proposed before.

Raw zImage /is/ the useful format that should be adopted.